#!/bin/bash

###################################################################
# Copyright (c) Members of the EGEE Collaboration. 2004. See
# http://www.eu-egee.org/partners/ for details on the copyright holders.
# 
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
###################################################################

wsdlname='www.gridsite.org-delegation'
docname='DelegationInterface'
workdir='../autogen/doc'
FOP='./fop-0.91beta/fop'

if [ ! -d $workdir ]; then mkdir $workdir; fi
version=$(awk -F'[ \t=]+' '/module.version/ { print $2 }' ../project/version.properties)

wsdldb="$workdir/$wsdlname-docbook.xml"
xsltproc --nonet --output $wsdldb wsdl-to-docbook.xsl ../interface/wsdl/www.gridsite.org-delegation-${version}.wsdl
#perl -pi -e 's/<db:/</g; s/<\/db:/<\//g; s/<(\w+)\s+xmlns:[^>]+>/<$1>/g' $wsdldb

wsdlnodoc="$workdir/$wsdlname-nodoc.xml"
echo '<literallayout class="monospaced"><![CDATA[' >$wsdlnodoc
xsltproc --nonet wsdl-strip-documentation.xsl ../interface/wsdl/${wsdlname}-${version}.wsdl | sed -e 's/xmlns:/\n    xmlns:/g' >>$wsdlnodoc
echo ']]></literallayout>' >>$wsdlnodoc

mysqldoc="$workdir/mysql-schema.sql.xml"
echo '<literallayout class="monospaced"><![CDATA[' >$mysqldoc
cat ../interface/schema/mysql/mysql-schema.sql >>$mysqldoc
echo ']]></literallayout>' >>$mysqldoc

# HTML output
xsltproc --xinclude --path .:$workdir --nonet --output $workdir/$docname.html html-output.xsl $docname.xml
cp $docname.css $workdir

# Plain text output
links $workdir/$docname.html -dump -dump-width 80 -no-numbering -no-references >$workdir/$docname.txt

exit

# PDF output
xsltproc --xinclude --path .:$workdir --nonet --output $workdir/$wsdlname.fo fo-output.xsl DelegationInterface.xml
$FOP -fo $workdir/$wsdlname.fo -pdf $workdir/DelegationInterface.pdf

